
Redmine - Feature #38585

Drop Ruby 2.7 and 3.0 support

2023-05-24 14:33 - C S

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Ruby support Estimated time: 0.00 hour

Target version: 6.0.0   

Resolution: Fixed   

Description

Ruby 2.7 is EOL (https://www.ruby-lang.org/en/downloads/branches/)

Since Redmine 4.2 supports Ruby 2.7 at most, this should also be set to EOL...

Related issues:

Related to Redmine - Patch #41865: Update SQLite3 gem to 2.5 Closed

Blocks Redmine - Patch #40197: Update commonmarker to 2.3.0 Closed

Associated revisions

Revision 22648 - 2024-01-27 03:20 - Go MAEDA

Drop Ruby 2.7 support (#38585).

Revision 22650 - 2024-01-27 06:43 - Go MAEDA

Fix RuboCop offense "Lint/Syntax: invalid escape character syntax" (#38585).

Revision 22651 - 2024-01-27 07:01 - Go MAEDA

Fix RuboCop offense Lint/RedundantDirGlobSort (#38585).

Revision 22652 - 2024-01-27 07:06 - Go MAEDA

Fix RuboCop offense Style/RedundantFreeze (#38585).

Revision 22653 - 2024-01-27 07:18 - Go MAEDA

Fix RuboCop offense Style/ArgumentsForwarding (#38585).

Revision 22654 - 2024-01-27 07:23 - Go MAEDA

Set TargetRubyVersion of RuboCop to 3.0 (#38585).

Revision 22971 - 2024-08-20 11:25 - Go MAEDA

Drop support for Ruby 3.0 due to Rails 7.2 update (#38585, #36320).

Revision 22972 - 2024-08-21 01:40 - Go MAEDA

Use Array#intersect? introduced in Ruby 3.1 (#38585).

Revision 22973 - 2024-08-21 02:46 - Go MAEDA

Use anonymous block forwarding introduced in Ruby 3.1 (#38585).

Revision 22974 - 2024-08-21 02:58 - Go MAEDA

Set Rubocop TargetRubyVersion to 3.1 (#38585).

History

#1 - 2023-05-26 19:51 - Milly texas

Dropping Ruby 2.7 support and setting Redmine 4.2 as EOL allows for focusing on newer technologies and ensuring compatibility with the latest

Ruby versions.

#2 - 2024-01-21 10:27 - Go MAEDA
- Subject changed from Drop Ruby 2.7 support and set Redmine 4.2 as EOL to Drop Ruby 2.7 support

- Category set to Ruby support

Support for Redmine 4.2 will end when the next major version (probably Redmine 6.0) is released.

#3 - 2024-01-21 10:33 - Go MAEDA

- Target version set to 6.0.0

Some Gems such as Nokogiri and SQLite have already discontinued support for Ruby 2.7.

I think it is fine to end support for Ruby 2.7 in Redmine 6.0.

#4 - 2024-01-22 03:05 - Marius BĂLTEANU

I totally agree.

#5 - 2024-01-27 03:33 - Go MAEDA

- Status changed from New to Resolved

Dropped Ruby 2.7 support in r22648.

I will set the TargetRailsVersion of RuboCop to 3.0 after fixing some RuboCop offenses regarding the update to Ruby 3.0.

#6 - 2024-01-27 07:25 - Go MAEDA

- Status changed from Resolved to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

I set TargetRubyVersion of RuboCop to 3.0 in r22654 after fixing the following offenses.

config/initializers/00-core_plugins.rb:4:44: W: [Correctable] Lint/RedundantDirGlobSort: Remove redundant sort

.

Dir.glob(Rails.root.join('lib/plugins/*')).sort.each do |directory|

                                           ^^^^

create_test_members.rb:1:1: C: [Correctable] Style/FrozenStringLiteralComment: Missing frozen string literal c

omment.

projects = Project.where(id: [1])

^

lib/redmine/plugin_loader.rb:70:43: W: [Correctable] Lint/RedundantDirGlobSort: Remove redundant sort.

      Dir.glob(File.join(directory, '*')).sort.each do |directory|

                                          ^^^^

lib/redmine/wiki_formatting/common_mark/fixup_auto_links_filter.rb:30:28: C: [Correctable] Style/RedundantFree

ze: Do not freeze immutable objects, as freezing them has no effect.

        USER_LINK_PREFIX = /(@|user:)\z/.freeze

                           ^^^^^^^^^^^^^^^^^^^^

lib/redmine/wiki_formatting/common_mark/fixup_auto_links_filter.rb:31:23: C: [Correctable] Style/RedundantFree

ze: Do not freeze immutable objects, as freezing them has no effect.

        HIRES_IMAGE = /.+@\dx\.(bmp|gif|jpg|jpe|jpeg|png)\z/.freeze

                      ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

test/test_helper.rb:255:30: C: [Correctable] Style/ArgumentsForwarding: Use shorthand syntax ... for arguments

 forwarding.

  def assert_select_in(text, *args, &block)

                             ^^^^^^^^^^^^^

test/test_helper.rb:257:22: C: [Correctable] Style/ArgumentsForwarding: Use shorthand syntax ... for arguments

 forwarding.

    assert_select(d, *args, &block)

                     ^^^^^^^^^^^^^

test/test_helper.rb:260:27: C: [Correctable] Style/ArgumentsForwarding: Use shorthand syntax ... for arguments

 forwarding.

  def assert_select_email(*args, &block)

                          ^^^^^^^^^^^^^

test/test_helper.rb:265:41: C: [Correctable] Style/ArgumentsForwarding: Use shorthand syntax ... for arguments

 forwarding.

    assert_select_in html_body.encoded, *args, &block

                                        ^^^^^^^^^^^^^

test/unit/lib/redmine/unified_diff_test.rb:403:40: F: Lint/Syntax: invalid escape character syntax

(Using Ruby 3.0 parser; configure using TargetRubyVersion parameter, under AllCops)

       $ hg commit -m `echo -e "U+1F603\U1F603"` -u `echo -e "U+1F603\U1F603"`
                                       ^

#7 - 2024-08-20 10:28 - Go MAEDA

- Subject changed from Drop Ruby 2.7 support to Drop Ruby 2.7 and 3.0 support

- Status changed from Closed to Reopened

Due to the update to Rails 7.2.0 in r22960, the trunk no longer supports Ruby 3.0.

Rails 7.2.0 requires Ruby 3.1.0 or later.

#8 - 2024-08-21 03:03 - Go MAEDA

- Status changed from Reopened to Closed

I changed the required Ruby version to 3.1 or higher in r22971, and incorporated the new features of Ruby 3.1 in r22972 and r22973.

I am closing this issue.

#9 - 2024-08-21 03:59 - Go MAEDA

- Blocks Patch #40197: Update commonmarker to 2.3.0 added

#10 - 2024-11-25 07:04 - Go MAEDA

- Related to Patch #41865: Update SQLite3 gem to 2.5 added
